=== added file 'src/com/goldencode/p2j/persist/InputDataSetParameter.java'
--- old/src/com/goldencode/p2j/persist/InputDataSetParameter.java	1970-01-01 00:00:00 +0000
+++ new/src/com/goldencode/p2j/persist/InputDataSetParameter.java	2022-05-12 15:03:49 +0000
@@ -0,0 +1,166 @@
+/*
+** Module   : InputDataSetParameter.java
+** Abstract : INPUT DATASET parameter support
+**
+** Copyright (c) 2019-2021, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- ---------------------------------------Description---------------------------------------
+** 001 GES 20210429 Created initial version, by moving code from the parent class.
+*/
+
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+**
+** Additional terms under GNU Affero GPL version 3 section 7:
+**
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+**
+**   0. Attribution Requirement.
+**
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+**
+**   1. No License To Use Trademarks.
+**
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+**
+**   2. No Misrepresentation of Affiliation.
+**
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+**
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+**
+**   3. No Misrepresentation of Source or Origin.
+**
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+
+package com.goldencode.p2j.persist;
+
+import com.goldencode.p2j.util.*;
+
+import java.util.*;
+
+/**
+ * Implements the INPUT DATASET parameter type. This hard codes the input/output flags and delegates
+ * all other processing to the parent class.
+ */
+public class InputDataSetParameter
+extends DataSetParameter
+{
+   /**
+    * Create a new parameter for the REMOTE dataset.
+    * 
+    * @param    wrapper
+    *           The REMOTE dataset.
+    */
+   public InputDataSetParameter(DatasetWrapper wrapper)
+   {
+      super(wrapper);
+   }
+   
+   /**
+    * Create an instance using a dataset reference.
+    *
+    * @param   dataset
+    *          Reference of the wrapped dataset.
+    */
+   public InputDataSetParameter(InputDataSetParameter dataset)
+   {
+      super(dataset.getDataset(), ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance using a dataset reference.
+    *
+    * @param   dataset
+    *          Reference of the wrapped dataset.
+    */
+   public InputDataSetParameter(DataSet dataset)
+   {
+      super(dataset, ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance using a dataset reference.
+    *
+    * @param   dataset
+    *          Reference of the wrapped dataset.
+    * @param   option
+    *          Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    */
+   public InputDataSetParameter(DataSet dataset, ParameterOption option)
+   {
+      super(dataset, option);
+   }
+      
+   /**
+    * Create an instance using a dataset handle.
+    *
+    * @param    dsHandle
+    *           Handle to the wrapped dataset.
+    */
+   public InputDataSetParameter(handle dsHandle)
+   {
+      super(dsHandle, ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance using a dataset handle.
+    *
+    * @param    dsHandle
+    *           Handle to the wrapped dataset.
+    * @param    option
+    *           Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    */
+   public InputDataSetParameter(handle dsHandle, ParameterOption option)
+   {
+      super(dsHandle, option);
+   }
+   
+   /**
+    * Determines if this parameter is INPUT or INPUT-OUTPUT.
+    *
+    * @return   Always {@code true}.
+    */
+   public boolean isInputMode()
+   {
+      return true;
+   }
+
+   /**
+    * Determines if this parameter is OUTPUT or INPUT-OUTPUT.
+    *
+    * @return   Always {@code false}.
+    */
+   public boolean isOutputMode()
+   {
+      return false;
+   }
+}

=== added file 'src/com/goldencode/p2j/persist/InputOutputDataSetHandle.java'
--- old/src/com/goldencode/p2j/persist/InputOutputDataSetHandle.java	1970-01-01 00:00:00 +0000
+++ new/src/com/goldencode/p2j/persist/InputOutputDataSetHandle.java	2022-05-12 15:03:49 +0000
@@ -0,0 +1,166 @@
+/*
+** Module   : InputOutputDataSetHandle.java
+** Abstract : INPUT-OUTPUT DATASET-HANDLE parameter support
+**
+** Copyright (c) 2019-2021, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- ---------------------------------------Description---------------------------------------
+** 001 GES 20210429 Created initial version, by moving code from the parent class.
+*/
+
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+**
+** Additional terms under GNU Affero GPL version 3 section 7:
+**
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+**
+**   0. Attribution Requirement.
+**
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+**
+**   1. No License To Use Trademarks.
+**
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+**
+**   2. No Misrepresentation of Affiliation.
+**
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+**
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+**
+**   3. No Misrepresentation of Source or Origin.
+**
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+
+package com.goldencode.p2j.persist;
+
+import com.goldencode.p2j.util.*;
+
+import java.util.*;
+
+/**
+ * Implements the INPUT-OUTPUT DATASET-HANDLE parameter type. This hard codes the input/output flags and
+ * delegates all other processing to the parent class.
+ */
+public class InputOutputDataSetHandle
+extends DataSetParameter
+{
+   /**
+    * Create a new parameter for the REMOTE dataset.
+    * 
+    * @param    wrapper
+    *           The REMOTE dataset.
+    */
+   public InputOutputDataSetHandle(DatasetWrapper wrapper)
+   {
+      super(wrapper);
+   }
+   
+   /**
+    * Create an instance using a dataset reference.
+    *
+    * @param   dataset
+    *          Reference of the wrapped dataset.
+    */
+   public InputOutputDataSetHandle(InputOutputDataSetHandle dataset)
+   {
+      super(dataset.getDataset(), ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance using a dataset reference.
+    *
+    * @param   dataset
+    *          Reference of the wrapped dataset.
+    */
+   public InputOutputDataSetHandle(DataSet dataset)
+   {
+      super(dataset, ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance using a dataset reference.
+    *
+    * @param   dataset
+    *          Reference of the wrapped dataset.
+    * @param   option
+    *          Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    */
+   public InputOutputDataSetHandle(DataSet dataset, ParameterOption option)
+   {
+      super(dataset, option);
+   }
+      
+   /**
+    * Create an instance using a dataset handle.
+    *
+    * @param    dsHandle
+    *           Handle to the wrapped dataset.
+    */
+   public InputOutputDataSetHandle(handle dsHandle)
+   {
+      super(dsHandle, ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance using a dataset handle.
+    *
+    * @param    dsHandle
+    *           Handle to the wrapped dataset.
+    * @param    option
+    *           Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    */
+   public InputOutputDataSetHandle(handle dsHandle, ParameterOption option)
+   {
+      super(dsHandle, option);
+   }
+   
+   /**
+    * Determines if this parameter is INPUT or INPUT-OUTPUT.
+    *
+    * @return   Always {@code true}.
+    */
+   public boolean isInputMode()
+   {
+      return true;
+   }
+
+   /**
+    * Determines if this parameter is OUTPUT or INPUT-OUTPUT.
+    *
+    * @return   Always {@code true}.
+    */
+   public boolean isOutputMode()
+   {
+      return true;
+   }
+}

=== added file 'src/com/goldencode/p2j/persist/InputOutputDataSetParameter.java'
--- old/src/com/goldencode/p2j/persist/InputOutputDataSetParameter.java	1970-01-01 00:00:00 +0000
+++ new/src/com/goldencode/p2j/persist/InputOutputDataSetParameter.java	2022-05-12 15:03:49 +0000
@@ -0,0 +1,166 @@
+/*
+** Module   : InputOutputDataSetParameter.java
+** Abstract : INPUT-OUTPUT DATASET-HANDLE parameter support
+**
+** Copyright (c) 2019-2021, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- ---------------------------------------Description---------------------------------------
+** 001 GES 20210429 Created initial version, by moving code from the parent class.
+*/
+
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+**
+** Additional terms under GNU Affero GPL version 3 section 7:
+**
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+**
+**   0. Attribution Requirement.
+**
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+**
+**   1. No License To Use Trademarks.
+**
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+**
+**   2. No Misrepresentation of Affiliation.
+**
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+**
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+**
+**   3. No Misrepresentation of Source or Origin.
+**
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+
+package com.goldencode.p2j.persist;
+
+import com.goldencode.p2j.util.*;
+
+import java.util.*;
+
+/**
+ * Implements the INPUT-OUTPUT DATASET parameter type. This hard codes the input/output flags and delegates
+ * all other processing to the parent class.
+ */
+public class InputOutputDataSetParameter
+extends DataSetParameter
+{
+   /**
+    * Create a new parameter for the REMOTE dataset.
+    * 
+    * @param    wrapper
+    *           The REMOTE dataset.
+    */
+   public InputOutputDataSetParameter(DatasetWrapper wrapper)
+   {
+      super(wrapper);
+   }
+   
+   /**
+    * Create an instance using a dataset reference.
+    *
+    * @param   dataset
+    *          Reference of the wrapped dataset.
+    */
+   public InputOutputDataSetParameter(InputOutputDataSetParameter dataset)
+   {
+      super(dataset.getDataset(), ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance using a dataset reference.
+    *
+    * @param   dataset
+    *          Reference of the wrapped dataset.
+    */
+   public InputOutputDataSetParameter(DataSet dataset)
+   {
+      super(dataset, ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance using a dataset reference.
+    *
+    * @param   dataset
+    *          Reference of the wrapped dataset.
+    * @param   option
+    *          Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    */
+   public InputOutputDataSetParameter(DataSet dataset, ParameterOption option)
+   {
+      super(dataset, option);
+   }
+      
+   /**
+    * Create an instance using a dataset handle.
+    *
+    * @param    dsHandle
+    *           Handle to the wrapped dataset.
+    */
+   public InputOutputDataSetParameter(handle dsHandle)
+   {
+      super(dsHandle, ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance using a dataset handle.
+    *
+    * @param    dsHandle
+    *           Handle to the wrapped dataset.
+    * @param    option
+    *           Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    */
+   public InputOutputDataSetParameter(handle dsHandle, ParameterOption option)
+   {
+      super(dsHandle, option);
+   }
+   
+   /**
+    * Determines if this parameter is INPUT or INPUT-OUTPUT.
+    *
+    * @return   Always {@code true}.
+    */
+   public boolean isInputMode()
+   {
+      return true;
+   }
+
+   /**
+    * Determines if this parameter is OUTPUT or INPUT-OUTPUT.
+    *
+    * @return   Always {@code true}.
+    */
+   public boolean isOutputMode()
+   {
+      return true;
+   }
+}

=== added file 'src/com/goldencode/p2j/persist/OutputDataSetHandle.java'
--- old/src/com/goldencode/p2j/persist/OutputDataSetHandle.java	1970-01-01 00:00:00 +0000
+++ new/src/com/goldencode/p2j/persist/OutputDataSetHandle.java	2022-05-12 15:03:49 +0000
@@ -0,0 +1,166 @@
+/*
+** Module   : OutputDataSetHandle.java
+** Abstract : OUTPUT DATASET-HANDLE parameter support
+**
+** Copyright (c) 2019-2021, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- ---------------------------------------Description---------------------------------------
+** 001 GES 20210429 Created initial version, by moving code from the parent class.
+*/
+
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+**
+** Additional terms under GNU Affero GPL version 3 section 7:
+**
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+**
+**   0. Attribution Requirement.
+**
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+**
+**   1. No License To Use Trademarks.
+**
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+**
+**   2. No Misrepresentation of Affiliation.
+**
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+**
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+**
+**   3. No Misrepresentation of Source or Origin.
+**
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+
+package com.goldencode.p2j.persist;
+
+import com.goldencode.p2j.util.*;
+
+import java.util.*;
+
+/**
+ * Implements the OUTPUT DATASET-HANDLE parameter type. This hard codes the input/output flags and delegates
+ * all other processing to the parent class.
+ */
+public class OutputDataSetHandle
+extends DataSetParameter
+{
+   /**
+    * Create a new parameter for the REMOTE dataset.
+    * 
+    * @param    wrapper
+    *           The REMOTE dataset.
+    */
+   public OutputDataSetHandle(DatasetWrapper wrapper)
+   {
+      super(wrapper);
+   }
+   
+   /**
+    * Create an instance using a dataset reference.
+    *
+    * @param   dataset
+    *          Reference of the wrapped dataset.
+    */
+   public OutputDataSetHandle(OutputDataSetHandle dataset)
+   {
+      super(dataset.getDataset(), ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance using a dataset reference.
+    *
+    * @param   dataset
+    *          Reference of the wrapped dataset.
+    */
+   public OutputDataSetHandle(DataSet dataset)
+   {
+      super(dataset, ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance using a dataset reference.
+    *
+    * @param   dataset
+    *          Reference of the wrapped dataset.
+    * @param   option
+    *          Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    */
+   public OutputDataSetHandle(DataSet dataset, ParameterOption option)
+   {
+      super(dataset, option);
+   }
+      
+   /**
+    * Create an instance using a dataset handle.
+    *
+    * @param    dsHandle
+    *           Handle to the wrapped dataset.
+    */
+   public OutputDataSetHandle(handle dsHandle)
+   {
+      super(dsHandle, ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance using a dataset handle.
+    *
+    * @param    dsHandle
+    *           Handle to the wrapped dataset.
+    * @param    option
+    *           Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    */
+   public OutputDataSetHandle(handle dsHandle, ParameterOption option)
+   {
+      super(dsHandle, option);
+   }
+   
+   /**
+    * Determines if this parameter is INPUT or INPUT-OUTPUT.
+    *
+    * @return   Always {@code false}.
+    */
+   public boolean isInputMode()
+   {
+      return false;
+   }
+
+   /**
+    * Determines if this parameter is OUTPUT or INPUT-OUTPUT.
+    *
+    * @return   Always {@code true}.
+    */
+   public boolean isOutputMode()
+   {
+      return true;
+   }
+}

=== added file 'src/com/goldencode/p2j/persist/OutputDataSetParameter.java'
--- old/src/com/goldencode/p2j/persist/OutputDataSetParameter.java	1970-01-01 00:00:00 +0000
+++ new/src/com/goldencode/p2j/persist/OutputDataSetParameter.java	2022-05-12 15:03:49 +0000
@@ -0,0 +1,166 @@
+/*
+** Module   : OutputDataSetParameter.java
+** Abstract : OUTPUT DATASET parameter support
+**
+** Copyright (c) 2019-2021, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- ---------------------------------------Description---------------------------------------
+** 001 GES 20210429 Created initial version, by moving code from the parent class.
+*/
+
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+**
+** Additional terms under GNU Affero GPL version 3 section 7:
+**
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+**
+**   0. Attribution Requirement.
+**
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+**
+**   1. No License To Use Trademarks.
+**
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+**
+**   2. No Misrepresentation of Affiliation.
+**
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+**
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+**
+**   3. No Misrepresentation of Source or Origin.
+**
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+
+package com.goldencode.p2j.persist;
+
+import com.goldencode.p2j.util.*;
+
+import java.util.*;
+
+/**
+ * Implements the OUTPUT DATASET parameter type. This hard codes the input/output flags and delegates
+ * all other processing to the parent class.
+ */
+public class OutputDataSetParameter
+extends DataSetParameter
+{
+   /**
+    * Create a new parameter for the REMOTE dataset.
+    * 
+    * @param    wrapper
+    *           The REMOTE dataset.
+    */
+   public OutputDataSetParameter(DatasetWrapper wrapper)
+   {
+      super(wrapper);
+   }
+   
+   /**
+    * Create an instance using a dataset reference.
+    *
+    * @param   dataset
+    *          Reference of the wrapped dataset.
+    */
+   public OutputDataSetParameter(OutputDataSetParameter dataset)
+   {
+      super(dataset.getDataset(), ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance using a dataset reference.
+    *
+    * @param   dataset
+    *          Reference of the wrapped dataset.
+    */
+   public OutputDataSetParameter(DataSet dataset)
+   {
+      super(dataset, ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance using a dataset reference.
+    *
+    * @param   dataset
+    *          Reference of the wrapped dataset.
+    * @param   option
+    *          Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    */
+   public OutputDataSetParameter(DataSet dataset, ParameterOption option)
+   {
+      super(dataset, option);
+   }
+      
+   /**
+    * Create an instance using a dataset handle.
+    *
+    * @param    dsHandle
+    *           Handle to the wrapped dataset.
+    */
+   public OutputDataSetParameter(handle dsHandle)
+   {
+      super(dsHandle, ParameterOption.NONE);
+   }
+   
+   /**
+    * Create an instance using a dataset handle.
+    *
+    * @param    dsHandle
+    *           Handle to the wrapped dataset.
+    * @param    option
+    *           Table parameter option (APPEND, BY-VALUE, BIND or BY-REFERENCE).
+    */
+   public OutputDataSetParameter(handle dsHandle, ParameterOption option)
+   {
+      super(dsHandle, option);
+   }
+   
+   /**
+    * Determines if this parameter is INPUT or INPUT-OUTPUT.
+    *
+    * @return   Always {@code false}.
+    */
+   public boolean isInputMode()
+   {
+      return false;
+   }
+
+   /**
+    * Determines if this parameter is OUTPUT or INPUT-OUTPUT.
+    *
+    * @return   Always {@code true}.
+    */
+   public boolean isOutputMode()
+   {
+      return true;
+   }
+}

=== modified file 'src/com/goldencode/p2j/persist/QueryWrapper.java'
--- old/src/com/goldencode/p2j/persist/QueryWrapper.java	2022-01-14 23:11:41 +0000
+++ new/src/com/goldencode/p2j/persist/QueryWrapper.java	2022-05-12 15:03:49 +0000
@@ -257,6 +257,7 @@
 **                           buffer list).
 **     CA  20210923          assign(CompoundQuery) must not reset the query.  Removed the 'closing' flag.
 **     OM  20220112          Added implementation of SKIP-DELETED-RECORD attribute.
+**     GES 20210501          Upgraded dataset parameter processing to match API changes.
 */
 
 /*
@@ -6893,7 +6894,7 @@
          SelfManager.pushSelf(self);
          
          // reference already assumes input-output, do not emit append
-         DataSetParameter dsp = new DataSetParameter(getDataSet(), false, ParameterOption.BY_REFERENCE);
+         DataSetParameter dsp = new DataSetParameter(getDataSet(), ParameterOption.BY_REFERENCE);
          if (cbd.getObject() != null)
          {
             // TODO:

=== modified file 'src/com/goldencode/p2j/persist/StaticDataSet.java'
--- old/src/com/goldencode/p2j/persist/StaticDataSet.java	2021-10-13 22:53:24 +0000
+++ new/src/com/goldencode/p2j/persist/StaticDataSet.java	2022-05-12 15:03:49 +0000
@@ -13,6 +13,7 @@
 **     CA  20201003 Use an identity HashSet where possible.
 **     OM  20211006 Unbinding occurs on procedure return instead of TM's scope finished.
 **     OM  20211011 Improved debugging support for proxy objects.
+**     GES 20210501 Upgraded table-handle parameter processing to match API changes.
 */
 
 /*
@@ -375,17 +376,14 @@
          bound.removeReference(this);
       }
       
-      ParameterOption mode = permanent ? ParameterOption.BIND 
-                                       : ParameterOption.BY_REFERENCE;
+      ParameterOption option = permanent ? ParameterOption.BIND : ParameterOption.BY_REFERENCE;
+      
       for (int i = 0; i < dsDef.getBuffers().size(); i++)
       {
          Temporary defBuf = (Temporary) dsDef.getBuffers().get(i);
          Temporary boundBuf = (Temporary) newBind.getBuffers().get(i);
          
-         TemporaryBuffer.associate(new TableParameter(boundBuf, false, mode), 
-                                   defBuf, 
-                                   input, output, false, 
-                                   mode);
+         TemporaryBuffer.associate(new TableParameter(boundBuf, option, input, output), defBuf, option);
       }
       
       DataSet oldBound = bound;

